<?php

use App\Budget\UstiProjectBudget;
use App\Model\Entity\Request;
use App\View\AppView;
use Cake\I18n\Number;
use CakePdf\View\PdfView;
use App\Model\Entity\ProjectBudgetDesign;

/**
 * @var $this AppView|PdfView
 * @var $request Request
 * @var $design_id DesignID
 */

if (empty($request) || !($request instanceof Request) || empty($request->request_budget)) {
    return;
}

// This is awkward, but a quick way to tell if the budget is still the original (aka V11) or V11_CHANGE, see #238
$extraData = isset($request->request_budget->extra_data) && !empty($request->request_budget->extra_data)
    ? unserialize($request->request_budget->extra_data)
    : null;

if (is_array($extraData) && count($extraData) < 7) {
    $nomangle = false;
    if ($design_id == ProjectBudgetDesign::DESIGN_USTI_V12_CHANGE) {
        $design_id = ProjectBudgetDesign::DESIGN_USTI_V12;
    }
    if ($design_id == ProjectBudgetDesign::DESIGN_USTI_V11_CHANGE) {
        $design_id = ProjectBudgetDesign::DESIGN_USTI_V11;
    }
} else {
    $nomangle = true;
}

$budgetHandler = new UstiProjectBudget($design_id);

$budgetHandler->loadBudget($request->request_budget, $nomangle);
?>

<table class="table table-striped">
    <tbody>
        <tr>
            <td><?= __('Celkové náklady/výdaje na projekt') ?></td>
            <td class="text-right"><?= Number::currency($request->request_budget->total_costs, 'CZK') ?></td>
        </tr>
        <tr>
            <td><?= __('Požadovaná výše dotace') ?></td>
            <td class="text-right"><?= Number::currency($request->request_budget->requested_amount, 'CZK') ?></td>
        </tr>
        <tr>
            <td><?= __('Podíl dotace na celkových nákladech (zaokrouhleno nahoru)') ?></td>
            <td class="text-right">
                <?php
                if ($request->request_budget->total_costs > 0) {
                    echo ceil($request->request_budget->requested_amount / $request->request_budget->total_costs * 100) . '%';
                } else {
                    echo 'n/a';
                }
                ?>
            </td>
        </tr>
</table>

<?php foreach ($budgetHandler->getSections() as $sectionId => $sectionParams) : ?>
    <?php
    $sectionFilledRows = $budgetHandler->getSectionFilledRows($sectionId);

    $sectionType = $sectionParams['type'] ?? 'default';
    $sectionTitle = $sectionParams['title'];
    $cardOpenTitle = $sectionParams['cardopen'] ?? false;
    $cardClose = $sectionParams['cardclose'] ?? false;
    ?>
    <?php if ($cardOpenTitle) : ?>
        <h3 class="text-center"><?= $cardOpenTitle ?></h3>
    <?php endif; ?>
    <?php if ($sectionFilledRows == 0) continue; ?>
    <h5><?= $sectionTitle ?></h5>
    <table class="table table-bordered" id="section-<?= $sectionId ?>">
        <colgroup>
            <col class="w-25">
            <col class="w-15">
            <col class="w-15">
            <col class="w-25">
            <col class="w-20">
        </colgroup>
        <thead>
            <tr>
                <?php foreach ($budgetHandler->getSectionHeaders($sectionId) as $columnHeader) : ?>
                    <th><?= $columnHeader ?></th>
                <?php endforeach; ?>
            </tr>
        </thead>
        <tbody>
            <?php for ($sectionRowCounter = 0; $sectionRowCounter < $budgetHandler->getSectionMaxRows($sectionId); $sectionRowCounter++) : ?>
                <?php // See #421 - due to a historical bug, there are empty budget lines sometimes, do not print them
                $empty_row = true;
                foreach ($budgetHandler->getSectionColumns($sectionId) as $columnId => $columnExtra) {
                    $data = $budgetHandler->getData(sprintf('%d.%d.%d', $sectionId, $sectionRowCounter, $columnId));
                    if (!empty(trim($data))) {
                        $empty_row = false;
                        break;
                    }
                }
                if ($empty_row) continue; //
                ?>
                <tr class="<?= $sectionRowCounter >= $sectionFilledRows ? 'd-none' : 'visible' ?>">
                    <?php foreach ($budgetHandler->getSectionColumns($sectionId) as $columnId => $columnExtra) : ?>
                        <td>
                            <?php
                            $data = $budgetHandler->getData(sprintf('%d.%d.%d', $sectionId, $sectionRowCounter, $columnId));
                            $data = translateSelections($budgetHandler->getSectionColumns($sectionId), $columnId, $data);
                            // see issue #565 added exception for TISNOV
                            if (
                                in_array($design_id, [ProjectBudgetDesign::DESIGN_USTI_V15, ProjectBudgetDesign::DESIGN_TISNOV]) &&
                                sprintf('%d.%d.%d', $sectionId, $sectionRowCounter, $columnId) == '8.0.1'
                            ) { // VZ15
                                $data = $request->request_budget->requested_amount;
                            }
                            echo $data;
                            ?>
                        </td>
                    <?php endforeach; ?>
                </tr>
            <?php endfor; ?>
        </tbody>
        <tfoot>
            <tr class="thead-dark">
                <?php foreach ($budgetHandler->getSectionFooters($sectionId) as $columnId => $attributes) : ?>
                    <th <?php foreach ($attributes as $name => $value) {
                            echo sprintf('%s="%s"', $name, $value);
                        } ?>><?= $attributes['text'] ?? '' ?></th>
                <?php endforeach; ?>
            </tr>
        </tfoot>
    </table>
<?php endforeach; ?>
<?php
function translateSelections($sectionColumnsDefs, $columnId, $value)
{
    return $sectionColumnsDefs[$columnId]['options'][$value] ?? $value;
}
